//
//  MyView.swift
//  Example31Scale
//
//  Created by 川上 博 on 2015/01/04.
//  Copyright (c) 2015年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

class MyView: NSView {
    var sfactor : [Double] = [1.0, 1.0]
    var xm : [Double] = [-3.0, 3.0]
    var ym : [Double] = [-3.0, 3.0]
    var wm : [Double] = [50.0, 30.0]
    var hm : [Double] = [50.0, 30.0]
    var la : [Double] = [0.2, 0.2]
    var lav : [Int] = [5, 5]
    
    override func awakeFromNib(){
        xm[0] = -3.0; xm[1] = 3.0; ym[0] = -3.0; ym[1] = 3.0;
        wm[0] = 50.0; wm[1] = 30.0; hm[0] = 50.0; hm[1] = 30.0;
        la[0] = 0.2; la[1] = 0.2; lav[0] = 5; lav[1] = 5;
    }
    
    override func drawRect(dirtyRect: NSRect) {
        NSColor.whiteColor().setFill()
        NSRectFill(self.bounds)
        
        sfactor[0] = (Double(self.bounds.size.width) - wm[0] - wm[1]) / (xm[1] - xm[0])
        sfactor[1] = (Double(self.bounds.size.height) - hm[0] - hm[1]) / (ym[1] - ym[0])
 
        self.drawAxes()
        //insert your program here.
        self.shape()
    }
    
    func shape() {
        let path = NSBezierPath()
        var a: [Double]=[0.0, 0.0]
        var b: [Double]=[0.0, 0.0]
        var c: [Double]=[0.0, 0.0]
        var d: [Double]=[0.0, 0.0]
        
        a[0]=sfactor[0]*(1.0-xm[0])+wm[0]
        a[1]=sfactor[1]*(1.0-ym[0])+hm[0]
        b[0]=sfactor[0]*(-1.0-xm[0])+wm[0]
        b[1]=sfactor[1]*(1.0-ym[0])+hm[0]
        c[0]=sfactor[0]*(-1.0-xm[0])+wm[0]
        c[1]=sfactor[1]*(-1.0-ym[0])+hm[0]
        d[0]=sfactor[0]*(1.0-xm[0])+wm[0]
        d[1]=sfactor[1]*(-1.0-ym[0])+hm[0]
        
        path.moveToPoint(NSMakePoint(CGFloat(a[0]),CGFloat(a[1])))
        path.lineToPoint(NSMakePoint(CGFloat(b[0]),CGFloat(b[1])))
        path.lineToPoint(NSMakePoint(CGFloat(c[0]),CGFloat(c[1])))
        path.lineToPoint(NSMakePoint(CGFloat(d[0]),CGFloat(d[1])))
        path.lineToPoint(NSMakePoint(CGFloat(a[0]),CGFloat(a[1])))
        
        NSColor.greenColor().set()
        path.lineWidth=4.0
        path.stroke()
    }
    
}