//
//  MyViewDynamics.swift
//  Example32vdP
//
//  Created by 川上 博 on 2015/01/04.
//  Copyright (c) 2015年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

extension MyView{
    
    func myfunc(inout x:[Double], inout f:[Double], inout t:Double){
        f[0] = x[1]
        f[1] = 1.0*(1.0-x[0]*x[0])*x[1]-x[0]
    }
    
    func runge(n:Int, h:Double, inout x:[Double], inout t:Double){
        var k1:[Double]=[0.0, 0.0], k2:[Double]=[0.0, 0.0], k3:[Double]=[0.0, 0.0]
        var k4:[Double]=[0.0, 0.0], xtemp:[Double]=[0.0, 0.0]
        var i:Int=0
        
        myfunc(&x, f: &k1, t: &t)
        for (i = 0; i < n; i++){
            xtemp[i] = x[i] + k1[i] / 2.0 * h
        }
        t += h/2.0
        myfunc(&xtemp, f: &k2, t: &t)
        for (i=0; i<n; i++){
            xtemp[i] = x[i] + k2[i] / 2.0 * h
        }
        myfunc(&xtemp, f: &k3, t: &t)
        for (i=0; i<n; i++){
            xtemp[i] = x[i] + k3[i] * h
        }
        t += h/2.0
        myfunc(&xtemp, f: &k4, t: &t)
        for (i=0; i<n; i++){
            x[i] += (k1[i]+2.0*(k2[i]+k3[i])+k4[i])/6.0*h
        }
    }
    
    func drawTrajectory(){
        var a:[Double]=[0.0, 0.0], u:[Double]=[0.0, 0.0]
        
        for(var i=0; i<1000; i++){
            a[0]=sfactor[0]*(x[0]-xm[0]);
            a[1]=sfactor[1]*(x[1]-ym[0]);
            
            runge(2, h: 0.04, x: &x, t: &t)
            
            u[0]=sfactor[0]*(x[0]-xm[0])
            u[1]=sfactor[1]*(x[1]-ym[0])
            bp.moveToPoint(NSMakePoint((CGFloat)(a[0]),(CGFloat)(a[1])))
            bp.lineToPoint(NSMakePoint((CGFloat)(u[0]),(CGFloat)(u[1])))
        }
        bp.stroke()
    }
    
}
