//
//  MyViewDynamics.swift
//  Example33ScaledvdP
//
//  Created by 川上 博 on 2015/01/04.
//  Copyright (c) 2015年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

extension MyView {
    
    func shape() {
        let path = NSBezierPath()
        var a: [Double]=[0.0, 0.0]
        var b: [Double]=[0.0, 0.0]
        var c: [Double]=[0.0, 0.0]
        var d: [Double]=[0.0, 0.0]
        
        a[0]=sfactor[0]*(1.0-xm[0])+wm[0]
        a[1]=sfactor[1]*(1.0-ym[0])+hm[0]
        b[0]=sfactor[0]*(-1.0-xm[0])+wm[0]
        b[1]=sfactor[1]*(1.0-ym[0])+hm[0]
        c[0]=sfactor[0]*(-1.0-xm[0])+wm[0]
        c[1]=sfactor[1]*(-1.0-ym[0])+hm[0]
        d[0]=sfactor[0]*(1.0-xm[0])+wm[0]
        d[1]=sfactor[1]*(-1.0-ym[0])+hm[0]
        
        path.moveToPoint(NSMakePoint(CGFloat(a[0]),CGFloat(a[1])))
        path.lineToPoint(NSMakePoint(CGFloat(b[0]),CGFloat(b[1])))
        path.lineToPoint(NSMakePoint(CGFloat(c[0]),CGFloat(c[1])))
        path.lineToPoint(NSMakePoint(CGFloat(d[0]),CGFloat(d[1])))
        path.lineToPoint(NSMakePoint(CGFloat(a[0]),CGFloat(a[1])))
        
        NSColor.greenColor().set()
        path.lineWidth=4.0
        path.stroke()
    }

    func myfunc(inout x:[Double], inout f:[Double], inout t:Double){
        f[0] = x[1]
        f[1] = 1.0*(1.0-x[0]*x[0])*x[1]-x[0]
    }
    
    func runge(n:Int, h:Double, inout x:[Double], inout t:Double){
        var k1:[Double]=[0.0, 0.0], k2:[Double]=[0.0, 0.0], k3:[Double]=[0.0, 0.0]
        var k4:[Double]=[0.0, 0.0], xtemp:[Double]=[0.0, 0.0]
        var i:Int=0
        
        myfunc(&x, f: &k1, t: &t)
        for (i = 0; i < n; i++){
            xtemp[i] = x[i] + k1[i] / 2.0 * h
        }
        t += h/2.0
        myfunc(&xtemp, f: &k2, t: &t)
        for (i=0; i<n; i++){
            xtemp[i] = x[i] + k2[i] / 2.0 * h
        }
        myfunc(&xtemp, f: &k3, t: &t)
        for (i=0; i<n; i++){
            xtemp[i] = x[i] + k3[i] * h
        }
        t += h/2.0
        myfunc(&xtemp, f: &k4, t: &t)
        for (i=0; i<n; i++){
            x[i] += (k1[i]+2.0*(k2[i]+k3[i])+k4[i])/6.0*h
        }
    }
    
    func drawTrajectory(){
        let bp = NSBezierPath()
        var a:[Double]=[0.0, 0.0], u:[Double]=[0.0, 0.0]
        
        for(var i=0; i<1000; i++){
            a[0]=sfactor[0]*(x[0]-xm[0]) + wm[0]
            a[1]=sfactor[1]*(x[1]-ym[0]) + hm[0]
            
            runge(2, h: 0.04, x: &x, t: &t)
            
            u[0]=sfactor[0]*(x[0]-xm[0]) + wm[0]
            u[1]=sfactor[1]*(x[1]-ym[0]) + hm[0]
            bp.moveToPoint(NSMakePoint((CGFloat)(a[0]),(CGFloat)(a[1])))
            bp.lineToPoint(NSMakePoint((CGFloat)(u[0]),(CGFloat)(u[1])))
        }
        NSColor.blueColor().set()
        bp.lineWidth=1.0
        bp.stroke()
    }
    
}
